/* ***********************************************************
 * This file was automatically generated on 2020-05-19.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.26                 *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures AC/DC current between -12.5A and +12.5A
	/// </summary>
	public class BrickletCurrent12 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 23;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Current12 Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_CALIBRATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_OVER_CURRENT = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_CURRENT = 15;

		private const int CALLBACK_ANALOG_VALUE = 16;

		private const int CALLBACK_CURRENT_REACHED = 17;

		private const int CALLBACK_ANALOG_VALUE_REACHED = 18;

		private const int CALLBACK_OVER_CURRENT = 19;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletCurrent12.SetCurrentCallbackPeriod"/>. The parameter is the current of the
		///  sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletCurrent12.CurrentCallback"/> callback is only triggered if the current has changed since
		///  the last triggering.
		/// </summary>
		public event CurrentEventHandler CurrentCallback;
		/// <summary>
		/// </summary>
		public delegate void CurrentEventHandler(BrickletCurrent12 sender, short current);

		/// <summary>
		/// </summary>
		public event CurrentEventHandler Current // for backward compatibility
		{
			add { CurrentCallback += value; }
			remove { CurrentCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletCurrent12.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value
		///  of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletCurrent12.AnalogValueCallback"/> callback is only triggered if the current has changed since the
		///  last triggering.
		/// </summary>
		public event AnalogValueEventHandler AnalogValueCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueEventHandler(BrickletCurrent12 sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueEventHandler AnalogValue // for backward compatibility
		{
			add { AnalogValueCallback += value; }
			remove { AnalogValueCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletCurrent12.SetCurrentCallbackThreshold"/> is reached.
		///  The parameter is the current of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletCurrent12.SetDebouncePeriod"/>.
		/// </summary>
		public event CurrentReachedEventHandler CurrentReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void CurrentReachedEventHandler(BrickletCurrent12 sender, short current);

		/// <summary>
		/// </summary>
		public event CurrentReachedEventHandler CurrentReached // for backward compatibility
		{
			add { CurrentReachedCallback += value; }
			remove { CurrentReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletCurrent12.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletCurrent12.SetDebouncePeriod"/>.
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueReachedEventHandler(BrickletCurrent12 sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReached // for backward compatibility
		{
			add { AnalogValueReachedCallback += value; }
			remove { AnalogValueReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when an over current is measured
		///  (see <see cref="Tinkerforge.BrickletCurrent12.IsOverCurrent"/>).
		/// </summary>
		public event OverCurrentEventHandler OverCurrentCallback;
		/// <summary>
		/// </summary>
		public delegate void OverCurrentEventHandler(BrickletCurrent12 sender);

		/// <summary>
		/// </summary>
		public event OverCurrentEventHandler OverCurrent // for backward compatibility
		{
			add { OverCurrentCallback += value; }
			remove { OverCurrentCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletCurrent12(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_CURRENT] = new CallbackWrapper(OnCurrentCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE] = new CallbackWrapper(OnAnalogValueCallback);
			callbackWrappers[CALLBACK_CURRENT_REACHED] = new CallbackWrapper(OnCurrentReachedCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE_REACHED] = new CallbackWrapper(OnAnalogValueReachedCallback);
			callbackWrappers[CALLBACK_OVER_CURRENT] = new CallbackWrapper(OnOverCurrentCallback);


			responseExpected[FUNCTION_GET_CURRENT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_CALIBRATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_OVER_CURRENT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CURRENT_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_CURRENT_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the current of the sensor.
		///  
		///  If you want to get the current periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletCurrent12.CurrentCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletCurrent12.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public short GetCurrent()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT);

			byte[] response = SendRequest(request, 10);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Calibrates the 0 value of the sensor. You have to call this function
		///  when there is no current present.
		///  
		///  The zero point of the current sensor
		///  is depending on the exact properties of the analog-to-digital converter,
		///  the length of the Bricklet cable and the temperature. Thus, if you change
		///  the Brick or the environment in which the Bricklet is used, you might
		///  have to recalibrate.
		///  
		///  The resulting calibration will be saved on the EEPROM of the Current
		///  Bricklet.
		/// </summary>
		public void Calibrate()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_CALIBRATE);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if more than 12.5A were measured.
		///  
		///  <note>
		///   To reset this value you have to power cycle the Bricklet.
		///  </note>
		/// </summary>
		public bool IsOverCurrent()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_OVER_CURRENT);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the value as read by a 12-bit analog-to-digital converter.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletCurrent12.GetCurrent"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletCurrent12.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletCurrent12.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog-to-digital converter.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletCurrent12.AnalogValueCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletCurrent12.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public int GetAnalogValue()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletCurrent12.CurrentCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletCurrent12.CurrentCallback"/> callback is only triggered if the current has changed since
		///  the last triggering.
		/// </summary>
		public void SetCurrentCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_CURRENT_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletCurrent12.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public long GetCurrentCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletCurrent12.AnalogValueCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletCurrent12.AnalogValueCallback"/> callback is only triggered if the analog value has
		///  changed since the last triggering.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletCurrent12.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public long GetAnalogValueCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletCurrent12.CurrentReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the current is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the current is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetCurrentCallbackThreshold(char option, short min, short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletCurrent12.SetCurrentCallbackThreshold"/>.
		/// </summary>
		public void GetCurrentCallbackThreshold(out char option, out short min, out short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.ShortFrom(9, response);
			max = LEConverter.ShortFrom(11, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletCurrent12.AnalogValueReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletCurrent12.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletCurrent12.CurrentReachedCallback"/>,
		///  * <see cref="Tinkerforge.BrickletCurrent12.AnalogValueReachedCallback"/>
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletCurrent12.SetCurrentCallbackThreshold"/>,
		///  * <see cref="Tinkerforge.BrickletCurrent12.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletCurrent12.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnCurrentCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short current = LEConverter.ShortFrom(8, response);
			var handler = CurrentCallback;

			if (handler != null)
			{
				handler(this, current);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnCurrentReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short current = LEConverter.ShortFrom(8, response);
			var handler = CurrentReachedCallback;

			if (handler != null)
			{
				handler(this, current);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueReachedCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnOverCurrentCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = OverCurrentCallback;

			if (handler != null)
			{
				handler(this);
			}
		}
	}
}
