/* ***********************************************************
 * This file was automatically generated on 2020-05-19.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.26                 *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Capacitive touch sensor for 12 electrodes
	/// </summary>
	public class BrickletMultiTouch : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 234;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Multi Touch Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TOUCH_STATE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_RECALIBRATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ELECTRODE_CONFIG = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ELECTRODE_CONFIG = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ELECTRODE_SENSITIVITY = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ELECTRODE_SENSITIVITY = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_TOUCH_STATE = 5;



		/// <summary>
		///  Returns the current touch state, see <see cref="Tinkerforge.BrickletMultiTouch.GetTouchState"/> for
		///  information about the state.
		///  
		///  This callback is triggered every time the touch state changes.
		/// </summary>
		public event TouchStateEventHandler TouchStateCallback;
		/// <summary>
		/// </summary>
		public delegate void TouchStateEventHandler(BrickletMultiTouch sender, int state);

		/// <summary>
		/// </summary>
		public event TouchStateEventHandler TouchState // for backward compatibility
		{
			add { TouchStateCallback += value; }
			remove { TouchStateCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletMultiTouch(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_TOUCH_STATE] = new CallbackWrapper(OnTouchStateCallback);


			responseExpected[FUNCTION_GET_TOUCH_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_RECALIBRATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SET_ELECTRODE_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_ELECTRODE_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ELECTRODE_SENSITIVITY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_ELECTRODE_SENSITIVITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the current touch state. The state is given as a bitfield.
		///  
		///  Bits 0 to 11 represent the 12 electrodes and bit 12 represents
		///  the proximity.
		///  
		///  If an electrode is touched, the corresponding bit is *true*. If
		///  a hand or similar is in proximity to the electrodes, bit 12 is
		///  *true*.
		///  
		///  Example: The state 4103 = 0x1007 = 0b1000000000111 means that
		///  electrodes 0, 1 and 2 are touched and that something is in the
		///  proximity of the electrodes.
		///  
		///  The proximity is activated with a distance of 1-2cm. An electrode
		///  is already counted as touched if a finger is nearly touching the
		///  electrode. This means that you can put a piece of paper or foil
		///  or similar on top of a electrode to build a touch panel with
		///  a professional look.
		/// </summary>
		public int GetTouchState()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TOUCH_STATE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Recalibrates the electrodes. Call this function whenever you changed
		///  or moved you electrodes.
		/// </summary>
		public void Recalibrate()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_RECALIBRATE);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Enables/disables electrodes with a bitfield (see <see cref="Tinkerforge.BrickletMultiTouch.GetTouchState"/>).
		///  
		///  *True* enables the electrode, *false* disables the electrode. A
		///  disabled electrode will always return *false* as its state. If you
		///  don't need all electrodes you can disable the electrodes that are
		///  not needed.
		///  
		///  It is recommended that you disable the proximity bit (bit 12) if
		///  the proximity feature is not needed. This will reduce the amount of
		///  traffic that is produced by the <see cref="Tinkerforge.BrickletMultiTouch.TouchStateCallback"/> callback.
		///  
		///  Disabling electrodes will also reduce power consumption.
		///  
		///  Default: 8191 = 0x1FFF = 0b1111111111111 (all electrodes and proximity feature enabled)
		/// </summary>
		public void SetElectrodeConfig(int enabledElectrodes)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_ELECTRODE_CONFIG);
			LEConverter.To((short)enabledElectrodes, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the electrode configuration, as set by <see cref="Tinkerforge.BrickletMultiTouch.SetElectrodeConfig"/>.
		/// </summary>
		public int GetElectrodeConfig()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ELECTRODE_CONFIG);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the sensitivity of the electrodes. An electrode with a high sensitivity
		///  will register a touch earlier then an electrode with a low sensitivity.
		///  
		///  If you build a big electrode you might need to decrease the sensitivity, since
		///  the area that can be charged will get bigger. If you want to be able to
		///  activate an electrode from further away you need to increase the sensitivity.
		///  
		///  After a new sensitivity is set, you likely want to call <see cref="Tinkerforge.BrickletMultiTouch.Recalibrate"/>
		///  to calibrate the electrodes with the newly defined sensitivity.
		/// </summary>
		public void SetElectrodeSensitivity(byte sensitivity)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_ELECTRODE_SENSITIVITY);
			LEConverter.To((byte)sensitivity, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current sensitivity, as set by <see cref="Tinkerforge.BrickletMultiTouch.SetElectrodeSensitivity"/>.
		/// </summary>
		public byte GetElectrodeSensitivity()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ELECTRODE_SENSITIVITY);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnTouchStateCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int state = LEConverter.UShortFrom(8, response);
			var handler = TouchStateCallback;

			if (handler != null)
			{
				handler(this, state);
			}
		}
	}
}
